import java.util.LinkedList;

import java.util.Arrays;

public class SternBrocot {

	private int p, q; // numérateur, dénominateur
	private SternBrocot left, right;

	SternBrocot(SternBrocot left, int p, int q, SternBrocot right) {
		this.p = p;
		this.q = q;
		this.left = left;
		this.right = right;
	}


	// seulement utilisé dans assert
	static int gcd(int n, int m) {
		return m == 0 ? n : gcd(m, n % m);
	}
	

	// construit l'arbre de Stern-Brocot des rationnels p/q avec
	// pl/ql < p/q < pr/qr et q <= limit
	static SternBrocot build(int pl, int ql, int pr, int qr, int limit) {
		assert pl * qr < pr * ql;
		assert gcd(pl, ql) == 1;
		assert gcd(pr, qr) == 1;
		// A completer:
	}

	// toutes les fractions réduites entre 0 et 1 de dénominateur <= limit
	static SternBrocot build(int limit) {
		return build(0, 1, 1, 1, limit);
	}



	static int size(SternBrocot t) {
	}


	static boolean isBST(SternBrocot t, int pl, int ql, int pr, int qr) {
	}



	static LinkedList<String> treeToList(SternBrocot t){
	}


	// le chemin (L pour left, R pour right) menant à x dans t
	// se termine par "!" si on trouve x dans t, sinon "?"
	static String path(SternBrocot t, int p, int q) {
	}	

	
	static int[] fromPath(String path) {
	}

	
	
	// la meilleure approximation rationnelle de x par défaut présente dans t
	// renvoyée comme un tableau de deux entiers
	static int[] lowApprox(SternBrocot t, double x) {
	}

	


	// ---- Seulement pour les tests ------
	// --------- Ne pas modifier ----------

	static boolean treeEquality(SternBrocot t1, SternBrocot t2) {
		if(t1 == null && t2 == null)
			return true;
		if(t1 == null || t2 == null)
			return false;
		return (t1.p == t2.p && t1.q == t2.q && treeEquality(t1.left, t2.left)
				&& treeEquality(t1.right, t2.right));
	}



}
