import java.util.LinkedList;
import java.util.HashSet;

public class Test1 {
	static boolean checkList(LinkedList<Personne> l, HashSet<Personne> reference) {
		if(l == null)
			return false;
		
		// verifie qu'il n'y a pas de doublons
		if(l.size() != reference.size())
			return false;
		for(Personne p : l) {
			if(!reference.contains(p))
				return false;
		}
		return true;
	}
	
	
	public static void main(String[] args) {
		String[] prenoms = new String[]{"Alan", "Marine", "Michel", "Anais", "Yves", "Amandine",
			"Arnaud", "Philippe", "Chloe", "Julie"};
		
		String[] noms = new String[] {"Turing", "Leroy", "Clerc", "Delarue", "Moulin", "Zapata",
				"Renoir", "Char", "Bernard", "Veron"};
			
		int[] ages = new int[] {42, 73, 82, 13, 36, 43, 51, 29, 1, 6};
		
		int tab1[] = new int[]{2, 7, 9, 5, 5, 0, 3, 2, 6, 9, 0, 2};
		int tab2[] = new int[]{1, 3, 0, 0, 4, 5, 1, 8, 9, 8};

		int tabMeet[] = new int[] {0, 3, 5, 9};
		int tabUnion[] = new int[] {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
		
		LinkedList<Personne> l1 = new LinkedList<Personne>();
		LinkedList<Personne> l2 = new LinkedList<Personne>();
		HashSet<Personne> meet = new HashSet<Personne>();		
		HashSet<Personne> union = new HashSet<Personne>();		
		
		for(Integer a : tab1)
			l1.add(new Personne(prenoms[a], noms[a], ages[a]));
		
		for(Integer a : tab2)
			l2.add(new Personne(prenoms[a], noms[a], ages[a]));
		
		for(Integer a : tabMeet)
			meet.add(new Personne(prenoms[a], noms[a], ages[a]));
		
		for(Integer a : tabUnion)
			union.add(new Personne(prenoms[a], noms[a], ages[a]));
		
		System.out.println("Liste 1 :  " + l1);
		System.out.println("Liste 2 :  " + l2);
		
		LinkedList<Personne> lMeet = UnionIntersection.intersection(l1, l2);
		LinkedList<Personne> lUnion = UnionIntersection.union(l1, l2);
		
		System.out.println("\n");
		System.out.println("Intersection :  " + lMeet);
		System.out.println("Union :  " + lUnion + "\n");
		
		System.out.println("Verification intersection:  " +
				(checkList(lMeet, meet) ? "[OK]" : "[FAILED]"));
		System.out.println("Verification union:         " +
				(checkList(lUnion, union) ? "[OK]" : "[FAILED]"));
	}
}
